---
title: Create incident attachment
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

# Create incident attachment{% #create-incident-attachment %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                  |
| ----------------- | ----------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/incidents/{incident_id}/attachments |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/incidents/{incident_id}/attachments |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/incidents/{incident_id}/attachments      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/incidents/{incident_id}/attachments      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/incidents/{incident_id}/attachments  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/incidents/{incident_id}/attachments     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/incidents/{incident_id}/attachments |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/incidents/{incident_id}/attachments |

### Overview

Create an incident attachment. This endpoint requires the `incident_write` permission.

OAuth apps require the `incident_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#incidents) to access this endpoint.



### Arguments

#### Path Parameters

| Name                          | Type   | Description               |
| ----------------------------- | ------ | ------------------------- |
| incident_id [*required*] | string | The UUID of the incident. |

#### Query Strings

| Name    | Type   | Description                                                                    |
| ------- | ------ | ------------------------------------------------------------------------------ |
| include | string | Resource to include in the response. Supported value: `last_modified_by_user`. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                  | Type   | Description                                                                        |
| ------------ | ---------------------- | ------ | ---------------------------------------------------------------------------------- |
|              | data                   | object | Attachment data for a create request.                                              |
| data         | attributes             | object | The attributes for creating an attachment.                                         |
| attributes   | attachment             | object | The attachment object for creating an attachment.                                  |
| attachment   | documentUrl            | string | The URL of the attachment.                                                         |
| attachment   | title                  | string | The title of the attachment.                                                       |
| attributes   | attachment_type        | enum   | The type of the attachment. Allowed enum values: `postmortem,link`                 |
| data         | id                     | string | The unique identifier of the attachment.                                           |
| data         | type [*required*] | enum   | The incident attachment resource type. Allowed enum values: `incident_attachments` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "attachment": {
        "documentUrl": "https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident",
        "title": "Example-Incident"
      },
      "attachment_type": "postmortem"
    },
    "type": "incident_attachments"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
An attachment response containing the attachment data and related objects.

| Parent field          | Field                           | Type            | Description                                                                        |
| --------------------- | ------------------------------- | --------------- | ---------------------------------------------------------------------------------- |
|                       | data                            | object          | Attachment data from a response.                                                   |
| data                  | attributes [*required*]    | object          | The attachment's attributes.                                                       |
| attributes            | attachment                      | object          | The attachment object.                                                             |
| attachment            | documentUrl                     | string          | The URL of the attachment.                                                         |
| attachment            | title                           | string          | The title of the attachment.                                                       |
| attributes            | attachment_type                 | enum            | The type of the attachment. Allowed enum values: `postmortem,link`                 |
| attributes            | modified                        | date-time       | Timestamp when the attachment was last modified.                                   |
| data                  | id [*required*]            | string          | The unique identifier of the attachment.                                           |
| data                  | relationships [*required*] | object          | The attachment's resource relationships.                                           |
| relationships         | incident                        | object          | Relationship to incident.                                                          |
| incident              | data [*required*]          | object          | Relationship to incident object.                                                   |
| data                  | id [*required*]            | string          | A unique identifier that represents the incident.                                  |
| data                  | type [*required*]          | enum            | Incident resource type. Allowed enum values: `incidents`                           |
| relationships         | last_modified_by_user           | object          | Relationship to user.                                                              |
| last_modified_by_user | data [*required*]          | object          | Relationship to user object.                                                       |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                      |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                  |
| data                  | type [*required*]          | enum            | The incident attachment resource type. Allowed enum values: `incident_attachments` |
|                       | included                        | [ <oneOf>] | A list of related objects included in the response.                                |
| included              | Option 1                        | object          | User object returned by the API.                                                   |
| Option 1              | attributes                      | object          | Attributes of user object returned by the API.                                     |
| attributes            | email                           | string          | Email of the user.                                                                 |
| attributes            | handle                          | string          | Handle of the user.                                                                |
| attributes            | icon                            | string          | URL of the user's icon.                                                            |
| attributes            | name                            | string          | Name of the user.                                                                  |
| attributes            | uuid                            | string          | UUID of the user.                                                                  |
| Option 1              | id                              | string          | ID of the user.                                                                    |
| Option 1              | type                            | enum            | Users resource type. Allowed enum values: `users`                                  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "attachment": {
        "documentUrl": "https://app.datadoghq.com/notebook/123/Postmortem-IR-123",
        "title": "Postmortem IR-123"
      },
      "attachment_type": "postmortem",
      "modified": "2025-01-01T01:01:01.000000001Z"
    },
    "id": "00000000-abcd-0002-0000-000000000000",
    "relationships": {
      "incident": {
        "data": {
          "id": "00000000-0000-0000-1234-000000000000",
          "type": "incidents"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "incident_attachments"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export incident_id="CHANGE_ME" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/incidents/${incident_id}/attachments" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "attachment": {
        "documentUrl": "https://app.datadoghq.com/notebook/123/Postmortem-IR-123",
        "title": "Postmortem-IR-123"
      },
      "attachment_type": "postmortem"
    },
    "type": "incident_attachments"
  }
}
EOF 
                        
##### 

```go
// Create incident attachment returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "incident" in the system
	IncidentDataID := os.Getenv("INCIDENT_DATA_ID")

	body := datadogV2.CreateAttachmentRequest{
		Data: &datadogV2.CreateAttachmentRequestData{
			Attributes: &datadogV2.CreateAttachmentRequestDataAttributes{
				Attachment: &datadogV2.CreateAttachmentRequestDataAttributesAttachment{
					DocumentUrl: datadog.PtrString("https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident"),
					Title:       datadog.PtrString("Example-Incident"),
				},
				AttachmentType: datadogV2.ATTACHMENTDATAATTRIBUTESATTACHMENTTYPE_POSTMORTEM.Ptr(),
			},
			Type: datadogV2.INCIDENTATTACHMENTTYPE_INCIDENT_ATTACHMENTS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateIncidentAttachment", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.CreateIncidentAttachment(ctx, IncidentDataID, body, *datadogV2.NewCreateIncidentAttachmentOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.CreateIncidentAttachment`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.CreateIncidentAttachment`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create incident attachment returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.Attachment;
import com.datadog.api.client.v2.model.AttachmentDataAttributesAttachmentType;
import com.datadog.api.client.v2.model.CreateAttachmentRequest;
import com.datadog.api.client.v2.model.CreateAttachmentRequestData;
import com.datadog.api.client.v2.model.CreateAttachmentRequestDataAttributes;
import com.datadog.api.client.v2.model.CreateAttachmentRequestDataAttributesAttachment;
import com.datadog.api.client.v2.model.IncidentAttachmentType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createIncidentAttachment", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    // there is a valid "incident" in the system
    String INCIDENT_DATA_ID = System.getenv("INCIDENT_DATA_ID");

    CreateAttachmentRequest body =
        new CreateAttachmentRequest()
            .data(
                new CreateAttachmentRequestData()
                    .attributes(
                        new CreateAttachmentRequestDataAttributes()
                            .attachment(
                                new CreateAttachmentRequestDataAttributesAttachment()
                                    .documentUrl(
                                        "https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident")
                                    .title("Example-Incident"))
                            .attachmentType(AttachmentDataAttributesAttachmentType.POSTMORTEM))
                    .type(IncidentAttachmentType.INCIDENT_ATTACHMENTS));

    try {
      Attachment result = apiInstance.createIncidentAttachment(INCIDENT_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#createIncidentAttachment");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create incident attachment returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.attachment_data_attributes_attachment_type import (
    AttachmentDataAttributesAttachmentType,
)
from datadog_api_client.v2.model.create_attachment_request import CreateAttachmentRequest
from datadog_api_client.v2.model.create_attachment_request_data import CreateAttachmentRequestData
from datadog_api_client.v2.model.create_attachment_request_data_attributes import CreateAttachmentRequestDataAttributes
from datadog_api_client.v2.model.create_attachment_request_data_attributes_attachment import (
    CreateAttachmentRequestDataAttributesAttachment,
)
from datadog_api_client.v2.model.incident_attachment_type import IncidentAttachmentType

# there is a valid "incident" in the system
INCIDENT_DATA_ID = environ["INCIDENT_DATA_ID"]

body = CreateAttachmentRequest(
    data=CreateAttachmentRequestData(
        attributes=CreateAttachmentRequestDataAttributes(
            attachment=CreateAttachmentRequestDataAttributesAttachment(
                document_url="https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident",
                title="Example-Incident",
            ),
            attachment_type=AttachmentDataAttributesAttachmentType.POSTMORTEM,
        ),
        type=IncidentAttachmentType.INCIDENT_ATTACHMENTS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_incident_attachment"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.create_incident_attachment(incident_id=INCIDENT_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create incident attachment returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_incident_attachment".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

# there is a valid "incident" in the system
INCIDENT_DATA_ID = ENV["INCIDENT_DATA_ID"]

body = DatadogAPIClient::V2::CreateAttachmentRequest.new({
  data: DatadogAPIClient::V2::CreateAttachmentRequestData.new({
    attributes: DatadogAPIClient::V2::CreateAttachmentRequestDataAttributes.new({
      attachment: DatadogAPIClient::V2::CreateAttachmentRequestDataAttributesAttachment.new({
        document_url: "https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident",
        title: "Example-Incident",
      }),
      attachment_type: DatadogAPIClient::V2::AttachmentDataAttributesAttachmentType::POSTMORTEM,
    }),
    type: DatadogAPIClient::V2::IncidentAttachmentType::INCIDENT_ATTACHMENTS,
  }),
})
p api_instance.create_incident_attachment(INCIDENT_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create incident attachment returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::CreateIncidentAttachmentOptionalParams;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::model::AttachmentDataAttributesAttachmentType;
use datadog_api_client::datadogV2::model::CreateAttachmentRequest;
use datadog_api_client::datadogV2::model::CreateAttachmentRequestData;
use datadog_api_client::datadogV2::model::CreateAttachmentRequestDataAttributes;
use datadog_api_client::datadogV2::model::CreateAttachmentRequestDataAttributesAttachment;
use datadog_api_client::datadogV2::model::IncidentAttachmentType;

#[tokio::main]
async fn main() {
    // there is a valid "incident" in the system
    let incident_data_id = std::env::var("INCIDENT_DATA_ID").unwrap();
    let body = CreateAttachmentRequest::new().data(
        CreateAttachmentRequestData::new(IncidentAttachmentType::INCIDENT_ATTACHMENTS).attributes(
            CreateAttachmentRequestDataAttributes::new()
                .attachment(
                    CreateAttachmentRequestDataAttributesAttachment::new()
                        .document_url(
                            "https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident"
                                .to_string(),
                        )
                        .title("Example-Incident".to_string()),
                )
                .attachment_type(AttachmentDataAttributesAttachmentType::POSTMORTEM),
        ),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateIncidentAttachment", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api
        .create_incident_attachment(
            incident_data_id.clone(),
            body,
            CreateIncidentAttachmentOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create incident attachment returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createIncidentAttachment"] = true;
const apiInstance = new v2.IncidentsApi(configuration);

// there is a valid "incident" in the system
const INCIDENT_DATA_ID = process.env.INCIDENT_DATA_ID as string;

const params: v2.IncidentsApiCreateIncidentAttachmentRequest = {
  body: {
    data: {
      attributes: {
        attachment: {
          documentUrl:
            "https://app.datadoghq.com/notebook/ExampleIncident/Example-Incident",
          title: "Example-Incident",
        },
        attachmentType: "postmortem",
      },
      type: "incident_attachments",
    },
  },
  incidentId: INCIDENT_DATA_ID,
};

apiInstance
  .createIncidentAttachment(params)
  .then((data: v2.Attachment) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
